com.corticon.eclipse.studio.rule.ruleflow.core

## Interface IRuleflowModelAPI

- All Superinterfaces:
    IModelAPI
  All Known Subinterfaces:
    IRuleflowDiagramModelAPI

      public interface IRuleflowModelAPI
      extends IModelAPI

  Ruleflow Model API implementation. This class contains methods needed to query and manipulate Ruleflow canonical model objects.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canSetRulesheetURI(org.eclipse.emf.common.util.URI aRulesheetURI)` Returns true, if the resource file represented by given URI is of type Rulesheet (.ers) and refers to the same vocabulary that is referred by the Ruleflow file.
    `boolean` | `containsServiceCallout()` Determines whether the Ruleflow contains any Rule Activities that are used for Service Callout
    `org.jdom.Document` | `createDefaultXmlReport(boolean abAddReportHeader)` Creates an XML Document that can be used for reporting purposes.
    `com.corticon.rulesemf.assetmodel.RuleflowAsset` | `createRuleflow(org.eclipse.emf.common.util.URI aURIRuleflow)` Create a new Ruleflow resource with the specified URI.
    `void` | `deleteRuleflow()` Delete the Ruleflow and remove its respective Resource.
    `com.corticon.rulesemf.canonicalrulemodel.ruleflow.Ruleflow` | `findRuleflow()` Finder for Ruleflow.
    `com.corticon.rulesemf.assetmodel.RuleflowAsset` | `findRuleflowAsset()` Finder for RuleflowAsset.
    `java.util.Date` | `getEffectiveDateStart()` Get effective date start.
    `java.util.Date` | `getEffectiveDateStop()` Get effective date stop.
    `java.util.Date` | `getExpirationDate()` Get expiration date.
    `java.util.List<java.lang.String>` | `getListServiceCalloutNames(boolean abIncludeBlankItem, boolean abBase)` Return a list of base or localized fully-qualified service call-out names culled from the extended operators.
    `int` | `getMajorVersion()` Get Ruleflow major version.
    `int` | `getMinorVersion()` Get Ruleflow minor version.
    `java.lang.String` | `getNewRuleflowName(org.eclipse.emf.common.util.URI aURIContainer)` Given the relative path of a container in the file system (project or folder), return a new unique Ruleflow name using sequence numbers if needed to ensure uniqueness.
    `IOperationsModelAPI` | `getOperationsModelAPI()` Return an instance of the Operations model API with its state set identically to *this* API.
    `java.lang.String` | `getRuleflowDescription()` Get ruleflow description.
    `IRulesheetModelAPI` | `getRulesheetModelAPI(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset aPRuleset)` Return an instance of Rulesheet model API for a given rulesheet.
    `IRulesheetTableModelAPI` | `getRulesheetTableModelAPI(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset aPRuleset)` Return an instance of Rulesheet table model API for a given rulesheet.
    `org.eclipse.emf.common.util.URI` | `getRulesheetURI(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset aPRuleset)` Return the URI associated with the specified PRuleset.
    `int` | `getTotalNumberOfRules()` Returns the total number of Rules for the Ruleflow.
    `java.lang.String` | `getVersionLabel()` Get version label.
    `IDomain` | `getVocabulary()` Get vocabulary root IDomain facade.
    `IVocabularyModelAPI` | `getVocabularyModelAPI()` Return an instance of the Vocabulary model API with its state set identically to *this* API.
    `org.eclipse.emf.common.util.URI` | `getVocabularyURI()` Return the URI of the Vocabulary, even if that Vocabulary is missing.
    `java.lang.String` | `getWorkDocumentEntityName()` Returns localized fully-qualified name of Work Document Entity.
    `boolean` | `incrementMajorVersion()` Increment the Major version.
    `boolean` | `incrementMinorVersion()` Increment the Minor version.
    `boolean` | `isDeployable()` Return an indication of whether this asset is deployable (i.e., whether the asset has any un-demoted errors).
    `boolean` | `isVocabularyAvailable()` Determine whether the Vocabulary for this Ruleflow is available.
    `void` | `presave()` Perform any necessary functions prior to saving.
    `boolean` | `renameRuleflow(org.eclipse.emf.common.util.URI aURIRuleflowNew)` Rename the Ruleflow.
    `boolean` | `setEffectiveDateStart(java.util.Date aDateEffectiveStart)` Set effective date start.
    `boolean` | `setEffectiveDateStop(java.util.Date aDateEffectiveStop)` Set effective date stop.
    `boolean` | `setExpirationDate(java.util.Date aDateExpiration)` Sets the Expiration Date.
    `boolean` | `setMajorVersion(int aiVersion)` Set Ruleflow major version.
    `boolean` | `setMinorVersion(int aiVersion)` Set Ruleflow minor version.
    `boolean` | `setRuleflowDescription(java.lang.String astrDescription)` Sets the Description for Ruleflow.
    `boolean` | `setVersionLabel(java.lang.String astrVersionLabel)` Sets the Version label
    `boolean` | `setVocabulary(IDomain aDomain)` Set the Ruleflow Vocabulary, technically a reference to the ecore root EPackage.
    `boolean` | `setWorkDocumentEntity(java.lang.String astrEntityName)` Sets the Work Document Entity.

    - ### Methods inherited from interface com.corticon.eclipse.core.IModelAPI

      `activate, addAnnotation, addBatchedModelListener, addLowLevelModelListener, addModelListener, addResourceListener, addView, beginTransaction, cancelTransaction, canSetSupportedLocales, closeResource, createResource, deleteAnnotation, deleteAnnotation, deleteAnnotation, deleteResource, displayMessageBox, dispose, doPostLoadValidation, doSmartValidation, endTransaction, endTransaction, flushCommandStack, formatValidationMessageLocation, formatValidationMessageText, getAllLocalesProvidingCompleteLocalization, getAnnotation, getAnnotations, getAnnotations, getAnnotations, getAPIContextObject, getAsset, getBaseAttribute, getBaseAttributeString, getBatchedModelListeners, getBuildNumber, getBuildNumberOfLastValidationRulesChange, getEditingDomain, getErrors, getErrors, getIndexByLocale, getLocale, getLocalizedAttribute, getLocalizedAttributeString, getLowLevelModelListeners, getMajorServiceNumber, getMajorVersionNumber, getMessage, getMessage, getMessageBase, getMessageBoxDelegate, getMinorServiceNumber, getMinorVersionNumber, getModelAPIState, getModelListeners, getNewResourceName, getPersistenceServicesDelegate, getPreferences, getPrimaryResource, getPrimaryResourceURI, getScrollableMessageDelegate, getSupportedLocales, getSuppressBrokenLinkValidation, getSuppressValidation, getToolTip, getUpdateStamp, getUserInterfaceInfoDelegate, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessages, getValidationMessages, getWarnings, getWarnings, handleException, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, isAPIStateEstablished, isEnabledRedo, isEnabledUndo, isInhibitNotification, isLoaded, isOperationModeNormal, isOperationModeRedo, isOperationModeUndo, isPassive, isPostLoadInProgress, isPrimaryResourceSet, isReadOnly, isResourceActivated, isResourceConflict, isResourceDemandLoaded, isResourceLoaded, isScrollableMessageDelegateAvailable, isShowCanonicalValidationMessages, isSuppressModifiedFlagUpdates, isSuppressPostLoad, isTransactionInProgress, isValid, isValid, loadResource, loadResource, loadResource, newInstance, noOperation, postLoad, postMethod, postMethod, postsave, preMethod, redo, reloadResource, remapResource, remapResource, removeBatchedModelListener, removeLowLevelModelListener, removeModelListener, removeResource, removeResourceListener, removeView, renameResource, rollbackTransaction, saveAll, saveResource, setAnnotation, setAPIContextObject, setAPIState, setBuildNumber, setEditingDomain, setInhibitNotification, setLocale, setMajorServiceNumber, setMajorVersionNumber, setMessageBoxDelegate, setMinorServiceNumber, setMinorVersionNumber, setModelAPIState, setModelListeners, setPassive, setPersistenceServicesDelegate, setPostLoadInProgress, setPreferencesDelegate, setPrimaryResource, setReadOnly, setScrollableMessageDelegate, setSupportedLocales, setSuppressBrokenLinkValidation, setSuppressModifiedFlagUpdates, setSuppressPostLoad, setSuppressValidation, setUserInterfaceInfoDelegate, undo, unloadResource, validate, validateLicense`

- - ### Method Detail

    - #### canSetRulesheetURI

          boolean canSetRulesheetURI(org.eclipse.emf.common.util.URI aRulesheetURI)

      Returns true, if the resource file represented by given URI is of type Rulesheet (.ers) and refers to the same vocabulary that is referred by the Ruleflow file.
      Parameters:
        `aRulesheetURI` -
      Returns:
        true, if the resource file represented by given URI is of type Rulesheet (.ers) and refers to the same vocabulary that is referred by the Ruleflow file.

    - #### createRuleflow

          com.corticon.rulesemf.assetmodel.RuleflowAsset createRuleflow(org.eclipse.emf.common.util.URI aURIRuleflow)

      Create a new Ruleflow resource with the specified URI. Example: platform:/resource/LoanProject/Loan.ruleflow
      Parameters:
        `aURIRuleflow` - New Ruleflow URI.
      Returns:
        New RuleflowAsset instance.

    - #### deleteRuleflow

          void deleteRuleflow()

      Delete the Ruleflow and remove its respective Resource.

    - #### findRuleflow

          com.corticon.rulesemf.canonicalrulemodel.ruleflow.Ruleflow findRuleflow()

      Finder for Ruleflow.
      Returns:
        Instance of Ruleflow.

    - #### findRuleflowAsset

          com.corticon.rulesemf.assetmodel.RuleflowAsset findRuleflowAsset()

      Finder for RuleflowAsset.
      Returns:
        Instance of RuleflowAsset.

    - #### getEffectiveDateStart

          java.util.Date getEffectiveDateStart()

      Get effective date start.
      Returns:
        Effective date start.

    - #### getEffectiveDateStop

          java.util.Date getEffectiveDateStop()

      Get effective date stop.
      Returns:
        Effective date stop.

    - #### getExpirationDate

          java.util.Date getExpirationDate()

      Get expiration date.
      Returns:
        Expiration date

    - #### getMajorVersion

          int getMajorVersion()

      Get Ruleflow major version.
      Returns:
        Ruleflow major version.

    - #### getMinorVersion

          int getMinorVersion()

      Get Ruleflow minor version.
      Returns:
        Ruleflow minor version.

    - #### getNewRuleflowName

          java.lang.String getNewRuleflowName(org.eclipse.emf.common.util.URI aURIContainer)

      Given the relative path of a container in the file system (project or folder), return a new unique Ruleflow name using sequence numbers if needed to ensure uniqueness.
      Parameters:
        `aURIContainer` - URI of container.
      Returns:
        New Ruleflow name.

    - #### getOperationsModelAPI

          IOperationsModelAPI getOperationsModelAPI()

      Return an instance of the Operations model API with its state set identically to *this* API.
      Returns:
        Instance of IOperationsModelAPI.

    - #### getRuleflowDescription

          java.lang.String getRuleflowDescription()

      Get ruleflow description.
      Returns:
        Ruleflow description.

    - #### getRulesheetModelAPI

          IRulesheetModelAPI getRulesheetModelAPI(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset aPRuleset)

      Return an instance of Rulesheet model API for a given rulesheet. Useful if simultaneously editing ruleflow and ruleflow's rulesheets.
      Parameters:
        `aPRuleset` - Ruleset whose API should be returned.
      Returns:
        Instance of Rulesheet model API.

    - #### getRulesheetTableModelAPI

          IRulesheetTableModelAPI getRulesheetTableModelAPI(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset aPRuleset)

      Return an instance of Rulesheet table model API for a given rulesheet.
      Parameters:
        `aPRuleset` - Ruleset whose API should be returned.
      Returns:
        Instance of Rulesheet model API.

    - #### getRulesheetURI

          org.eclipse.emf.common.util.URI getRulesheetURI(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset aPRuleset)

      Return the URI associated with the specified PRuleset.
      Parameters:
        `aPRuleset` - PRuleset instance whose URI is to be returned.
      Returns:
        URI of Rulesheet.

    - #### getTotalNumberOfRules

          int getTotalNumberOfRules()

      Returns the total number of Rules for the Ruleflow.
      Returns:
        Total number of rules in Ruleflow.

    - #### getVersionLabel

          java.lang.String getVersionLabel()

      Get version label.
      Returns:
        Version label.

    - #### getVocabulary

          IDomain getVocabulary()

      Get vocabulary root IDomain facade.
      Returns:
        IDomain instance representing Vocabulary root node.

    - #### getVocabularyModelAPI

          IVocabularyModelAPI getVocabularyModelAPI()

      Return an instance of the Vocabulary model API with its state set identically to *this* API. This Vocabulary API instance can be used for parsing utilities or any other purpose.
      Returns:
        Instance of IVocabularyModelAPI.

    - #### getVocabularyURI

          org.eclipse.emf.common.util.URI getVocabularyURI()

      Return the URI of the Vocabulary, even if that Vocabulary is missing.
      Returns:
        URI of Vocabulary.

    - #### getWorkDocumentEntityName

          java.lang.String getWorkDocumentEntityName()

      Returns localized fully-qualified name of Work Document Entity.
      Returns:
        Localized, fully-qualified entity name.

    - #### incrementMajorVersion

          boolean incrementMajorVersion()

      Increment the Major version.
      Returns:
        `true` if the command was successful.

    - #### incrementMinorVersion

          boolean incrementMinorVersion()

      Increment the Minor version.
      Returns:
        `true` if the command was successful.

    - #### isVocabularyAvailable

          boolean isVocabularyAvailable()

      Determine whether the Vocabulary for this Ruleflow is available.
      Returns:
        `true` if Vocabulary is available.

    - #### presave

          void presave()

      Perform any necessary functions prior to saving.
      Specified by:
        `presave` in interface `IModelAPI`

    - #### renameRuleflow

          boolean renameRuleflow(org.eclipse.emf.common.util.URI aURIRuleflowNew)

      Rename the Ruleflow.
      Parameters:
        `aURIRuleflowNew` - New Ruleflow URI.
      Returns:
        `true` if the command was successful.

    - #### setEffectiveDateStart

          boolean setEffectiveDateStart(java.util.Date aDateEffectiveStart)

      Set effective date start.
      Parameters:
        `aDateEffectiveStart` - Effective start date.
      Returns:
        `true` if the set command was successful.

    - #### setEffectiveDateStop

          boolean setEffectiveDateStop(java.util.Date aDateEffectiveStop)

      Set effective date stop.
      Parameters:
        `aDateEffectiveStop` - Effective stop date.
      Returns:
        `true` if the set command was successful.

    - #### setExpirationDate

          boolean setExpirationDate(java.util.Date aDateExpiration)

      Sets the Expiration Date.
      Parameters:
        `aDateExpiration` - Expiration date.
      Returns:
        `true` if the set command was successful.

    - #### setMajorVersion

          boolean setMajorVersion(int aiVersion)

      Set Ruleflow major version.
      Parameters:
        `aiVersion` - Major version.
      Returns:
        `true` if the set command was successful.

    - #### setMinorVersion

          boolean setMinorVersion(int aiVersion)

      Set Ruleflow minor version.
      Parameters:
        `aiVersion` - Ruleflow minor version.
      Returns:
        `true` if the set command was successful.

    - #### setRuleflowDescription

          boolean setRuleflowDescription(java.lang.String astrDescription)

      Sets the Description for Ruleflow.
      Parameters:
        `astrDescription` - Ruleflow description.
      Returns:
        `true` if the set command was successful.

    - #### setVersionLabel

          boolean setVersionLabel(java.lang.String astrVersionLabel)

      Sets the Version label
      Parameters:
        `astrVersionLabel` - Version label.
      Returns:
        `true` if the set command was successful.

    - #### setVocabulary

          boolean setVocabulary(IDomain aDomain)

      Set the Ruleflow Vocabulary, technically a reference to the ecore root EPackage.
      Parameters:
        `aEPackage` - EPackage root of chosen ecore document.
      Returns:
        `true` if the set command was successful.

    - #### setWorkDocumentEntity

          boolean setWorkDocumentEntity(java.lang.String astrEntityName)

      Sets the Work Document Entity.
      Parameters:
        `astrEntityName` - Localized, fully-qualified entity name.
      Returns:
        boolean `true` if set successfully.

    - #### isDeployable

          boolean isDeployable()

      Return an indication of whether this asset is deployable (i.e., whether the asset has any un-demoted errors).
      Returns:
        `true` if the asset is deployable.

    - #### containsServiceCallout

          boolean containsServiceCallout()

      Determines whether the Ruleflow contains any Rule Activities that are used for Service Callout
      Returns:
        `true` if the Ruleflow contains at least 1 Service Callout Activity

    - #### createDefaultXmlReport

          org.jdom.Document createDefaultXmlReport(boolean abAddReportHeader)

      Creates an XML Document that can be used for reporting purposes.
      Parameters:
        `abAddReportHeader` - Determines if the report header will be added to the result document
      Returns:
        Document Xml report document

    - #### getListServiceCalloutNames

          java.util.List<java.lang.String> getListServiceCalloutNames(boolean abIncludeBlankItem,
                                                                    boolean abBase)

      Return a list of base or localized fully-qualified service call-out names culled from the extended operators. The list may optionally include a blank value at the top.
      Parameters:
        `abIncludeBlankItem` - `true` to include blank item.
        `abBase` - `true` to return base values.
      Returns:
        List of all service call-out names.

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.